package processing.test.agent_test_1;

import processing.core.*; 
import processing.data.*; 
import processing.opengl.*; 

import android.view.MotionEvent; 
import android.view.KeyEvent; 
import android.graphics.Bitmap; 
import java.io.*; 
import java.util.*; 

public class agent_test_1 extends PApplet {


class MovingPoint {
  float xPos, yPos, speed;
  float direction;
  int theColor;

  MovingPoint(int X, int Y) {
    this.xPos = X;
    this.yPos = Y;
    this.direction = random(0, 40);  //1,2,3,4 O S W N
    this.speed = random(1, 3);
    this.theColor = color(random(1,100),random(1,100),random(1,100));
    
  }

  public void update() {

    //chance 10%, dass die Richtung wechselt
    if (PApplet.parseInt(random(1, 50)) == 5) {
      direction = random(0, 40);
      speed = random(1, 3);
    }



    if (direction < 10) { //osten
      xPos = xPos + (0.5f * speed);
      yPos = yPos + (random(-0.5f, 0.5f) * speed);
    } 
    else if (direction < 20) { //sueden.
      xPos = xPos + (random(-0.5f, 0.5f) * speed);
      yPos = yPos + (0.5f * speed);
    } 
    else if (direction < 30) { //westen
      xPos = xPos - (0.5f * speed);
      yPos = yPos + (random(-0.5f, 0.5f) * speed);
    } 
    else if (direction < 40) { //norden
      xPos = xPos + (random(-0.5f, 0.5f) * speed);
      yPos = yPos - (0.5f * speed);
    }    

    //wenn Punkt in den Rand geht, neue Richtung und Koordinaten zuruecksetzen
    if (xPos < 4) { //wenn zu weit westen dann osten
      direction = 1;
      speed = 15;
      xPos = xPos + 10;
    } 
    else if (xPos > width-4) {  //wenn zu weit im Osten
      direction = 3;
      speed = 15;
      xPos = xPos - 10;
    } 
    else if (yPos < 4) {
      direction = 2;
      speed = 15;
      yPos = yPos + 10;
    } 
    else if (yPos > height-4) {
      direction = 4;
      speed = 15;
      yPos = yPos - 10;
    }


    fill(theColor);
    ellipse(xPos, yPos, (30/speed)+3, 30+3);
  }
}

MovingPoint points[] = new MovingPoint[1000];
int pointAmount = 0;

public void setup() {
 
  frameRate(45);
  colorMode(HSB, 100, 100, 100);
  background(0, 0, 0);

  for (int i=1; i<19;i++) {
    pointAmount++;
    points[i] = new MovingPoint(PApplet.parseInt(random(1, width)), PApplet.parseInt(random(1, height)));
    points[i].update();
  }
}

public void draw() {
  background(0, 0, 0);
  for (int i=1; i<pointAmount-1;i++) {
    points[i].update();
  }
  
}

public void mouseDragged() {
  if(pointAmount < 500){
  pointAmount++;
  points[pointAmount] = new MovingPoint(mouseX, mouseY);

  points[pointAmount].update();
  }
}


  public int sketchWidth() { return 350; }
  public int sketchHeight() { return 700; }
  public String sketchRenderer() { return P2D; }
}
